export function flattenPatterns(hierarchies: string[], { patterns }: {
    patterns: string[];
}): string[];
export function flattenFix(hierarchy: boolean | undefined, { fix }: {
    fix: boolean | undefined;
}): boolean | undefined;
export function flattenLevel(hierarchy: Level, { level }: {
    level: Level;
}): Level;
export function flattenOptions(hierarchies: Record<string, any>[], { options }: {
    options: Record<string, any>;
}): Record<string, any>;
export function flattenReporter(hierarchy: NormalizedConfigReporter, { level }: {
    level: Level;
}): FlattenedConfigReporter;
export function flattenReporters(hierarchies: NormalizedConfigReporter[], { formatter, level }: {
    formatter: TypeofFormatter;
    level: Level;
}): FlattenedConfigReporter[];
export function flattenLinter(hierarchy: NormalizedConfigLinter, { fix, level, options }: {
    fix: boolean | undefined;
    level: Level;
    options: Record<string, any>;
}): FlattenedConfigLinter;
export function flattenLinters(hierarchies: NormalizedConfigLinter[], { fix, level }: {
    fix: boolean | undefined;
    level: Level;
}): FlattenedConfigLinter[];
export function flattenOverride(hierarchy: NormalizedConfigOverride, { fix, level }: {
    fix: boolean | undefined;
    level: Level;
}): FlattenedConfigOverride;
export function flattenChecker(hierarchy: NormalizedConfigChecker, { fix, level }: {
    fix: boolean | undefined;
    level: Level;
}): FlattenedConfigChecker;
export function flatten(hierarchy: NormalizedConfig, argv: {
    fix: boolean | undefined;
    formatter: TypeofFormatter | undefined;
    level: Level | undefined;
}): FlattenedConfig;
export default flatten;
export type TypeofFormatter = import("../formatter/formatter.js").default;
export type FlattenedConfig = import("../../type/index.d.ts").FlattenedConfig;
export type FlattenedConfigChecker = import("../../type/index.d.ts").FlattenedConfigChecker;
export type FlattenedConfigLinter = import("../../type/index.d.ts").FlattenedConfigLinter;
export type FlattenedConfigOverride = import("../../type/index.d.ts").FlattenedConfigOverride;
export type FlattenedConfigReporter = import("../../type/index.d.ts").FlattenedConfigReporter;
export type Level = import("../../type/index.d.ts").Level;
export type NormalizedConfig = import("../../type/index.d.ts").NormalizedConfig;
export type NormalizedConfigChecker = import("../../type/index.d.ts").NormalizedConfigChecker;
export type NormalizedConfigLinter = import("../../type/index.d.ts").NormalizedConfigLinter;
export type NormalizedConfigOverride = import("../../type/index.d.ts").NormalizedConfigOverride;
export type NormalizedConfigReporter = import("../../type/index.d.ts").NormalizedConfigReporter;
