/**
 * Le formateur qui écrit les résultats dans un format CSV.
 *
 * @see https://tools.ietf.org/html/rfc4180
 */
export default class CSVFormatter extends Formatter {
    /**
     * Crée un formateur.
     *
     * @param {Level}    level            Le niveau de sévérité minimum des
     *                                    notifications affichées.
     * @param {Object}   options          Les options du formateur.
     * @param {Writable} [options.writer] Le flux où écrire les résultats.
     */
    constructor(level: Level, options: {
        writer?: Writable;
    });
    #private;
}
export type Writable = import("node:stream").Writable;
export type Level = import("../../type/index.js").Level;
export type Notice = import("../../type/index.js").Notice;
import Formatter from "./formatter.js";
