/**
 * @typedef {import("../type/index.d.ts").FlattenedConfigChecker} FlattenedConfigChecker
 * @typedef {import("../type/index.d.ts").Notice} Notice
 */
export default class Metalint {
    static fromFileSystem(options?: {}): Promise<Metalint>;
    constructor(config: any);
    /**
     * Vérifie (en appelant des linters) des répertoires et des fichiers.
     *
     * @param {string[]} bases Les répertoires et les fichiers.
     * @returns {Promise<Record<string, Notice[]|undefined>>} Une promesse
     *                                                        retournant la
     *                                                        liste des
     *                                                        notifications
     *                                                        regroupées par
     *                                                        fichier.
     */
    lintFiles(bases: string[]): Promise<Record<string, Notice[] | undefined>>;
    report(results: any): Promise<any>;
    #private;
}
export type FlattenedConfigChecker = import("../type/index.d.ts").FlattenedConfigChecker;
export type Notice = import("../type/index.d.ts").Notice;
