/**
 * @typedef {import("../../type/index.d.ts").Level} Level
 * @typedef {import("../../type/index.d.ts").PartialNotice} PartialNotice
 */
/**
 * L'enrobage du linter <strong>JSON Lint (mod)</strong>.
 *
 * @see https://www.npmjs.com/package/jsonlint-mod
 */
export default class JSONLintModWrapper extends Wrapper {
    /**
     * Crée un enrobage pour le linter <strong>JSON Lint (mod)</strong>.
     *
     * @param {Object}              context       Le contexte de l'enrobage.
     * @param {Level}               context.level Le niveau de sévérité minimum
     *                                            des notifications retournées.
     * @param {boolean}             context.fix   La marque indiquant s'il faut
     *                                            corriger le fichier.
     * @param {string}              context.root  L'adresse du répertoire où se
     *                                            trouve le répertoire
     *                                            <code>.metalint/</code>.
     * @param {string[]}            context.files La liste de tous les fichiers
     *                                            analysés.
     * @param {Record<string, any>} _options      Les non-options du linter.
     */
    constructor(context: {
        level: Level;
        fix: boolean;
        root: string;
        files: string[];
    }, _options: Record<string, any>);
}
export type Level = import("../../type/index.d.ts").Level;
export type PartialNotice = import("../../type/index.d.ts").PartialNotice;
import Wrapper from "./wrapper.js";
