/**
 * L'enrobage du linter <strong>publint</strong>.
 *
 * @see https://www.npmjs.com/package/publint
 */
export default class PublintWrapper extends Wrapper {
    /**
     * Crée un enrobage pour le linter <strong>publint</strong>.
     *
     * @param {Object}              context       Le contexte de l'enrobage.
     * @param {Level}               context.level Le niveau de sévérité minimum
     *                                            des notifications retournées.
     * @param {boolean}             context.fix   La marque indiquant s'il faut
     *                                            corriger le fichier.
     * @param {string}              context.root  L'adresse du répertoire où se
     *                                            trouve le répertoire
     *                                            <code>.metalint/</code>.
     * @param {string[]}            context.files La liste de tous les fichiers
     *                                            analysés.
     * @param {Record<string, any>} options       Les options du linter.
     */
    constructor(context: {
        level: Level;
        fix: boolean;
        root: string;
        files: string[];
    }, options: Record<string, any>);
    #private;
}
export type Level = import("../../type/index.d.ts").Level;
export type Severity = import("../../type/index.d.ts").Severity;
export type PartialNotice = import("../../type/index.d.ts").PartialNotice;
import Wrapper from "./wrapper.js";
